package com.logicbig.example;

import org.springframework.cache.Cache;
import org.springframework.cache.CacheManager;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import java.util.Map;


public class ExampleMain {

    public static void main(String[] args) {
        AnnotationConfigApplicationContext context = new AnnotationConfigApplicationContext(AppConfig.class);
        EmployeeService employeeService = context.getBean(EmployeeService.class);
        System.out.println("-- getting employee by id --");
        Employee employee = employeeService.getEmployeeById(10);
        System.out.println("employee returned: " + employee);

        System.out.println("-- getting employee by name and dept --");
        employee = employeeService.getEmployeeByNameAndDept("Linda", "Admin");
        System.out.println("employee returned: " + employee);

        printNativeCache(context);
    }

    public static void printNativeCache(ApplicationContext context) {
        Cache cache = context.getBean(CacheManager.class).getCache("employee-cache");
        System.out.println("-- native cache --");
        Map<String, Object> map = (Map<String, Object>) cache.getNativeCache();
        map.forEach((key, value) -> {
            System.out.println(key + " = " + value);
        });
    }
}